$eolcom @

SETS
         T    Sett av tidsperioder   / 1*50/
         G    Sett av grupper      /1*3/
              alias (G,J)

SCALARS
* alle kostnader er i 1000

         QS  Kapasitet sykehusplasser /10000/
         QV  Kapasitet vaksinebeholdning per periode /88000/ @dette er det samme som QH, men vi regner med at QV blir begrensende faktor
         QIB Kapasitet intensivplasser /300/

         CS  Sykehuskostnad /64.75/
         CH  Kostnad per vaksine helsepersonale /0.060/
         CV  Vaksinekostnad /0.080/
         CIB Kostnad per ytterligere intensivplass /204/

         E   Vaksineeffekt /0.80/           ;


PARAMETERS
* alle kostnader er i 1000

         CF(G)  Kostnad ved fravr gruppe g / 1 0.448
                                              2 0.7
                                              3 0  /

         CB(G)  Kostnad bivirkninger gruppe g /1 2318.343
                                               2 2205.363
                                               3 1689.999  /



         KS(G)  Andel av syke i gruppe g som blir innlagt p sykehus /1 0.0012
                                                             2 0.0017
                                                            3 0.0047 /


         KIB(G) Andel av innlagte pasienter i gruppe g som m ha intensivbehandling /1 0.0573
                                                                                     2 0.2003
                                                                                     3 0.1176 /


         KB(G)  Andel av vaksinerte i gruppe g som fr bivirkninger /1 0.00012
                                                                     2 0.00002
                                                                     3 0 /



         AM(G)  Antall mottakelige initielt i gruppe g   /1 1231423
                                                          2 2631561
                                                          3  493290  /

         AS(G)  Antall syke initielt i gruppe g /1 7
                                                 2 5
                                                 3 1/

         AI(G)  Antall immune initielt i gruppe g /1 0
                                                   2 319642
                                                  3 123323  /

         N(G)   Antall personer i gruppe g /1 1231430
                                            2 2951208
                                            3 616614/


         W(G)   Per individ kontaktrate for gruppe g (lik for alle perioder) /1  15.3
                                                                              2  13
                                                                              3  8.2 /

         BETA(G) Sannynlighet for smitte ved kontakt for gruppe g    / 1 0.111
                                                                       2 0.098
                                                                       3 0.060 /



TABLE  U(G,J) Andel av gruppe g dine kontakter som er med gruppe j
            1           2           3
1           0.79        0.20        0.02
2           0.10        0.84        0.06
3           0.06        0.46        0.49


VARIABLES

         M(T, G)  Antall mottakelige i steg t gruppe g
         S(T, G)  Antall syke i steg t gruppe g
         I(T, G)  Antall immune i steg t gruppe g

*         L(T, G)  Andel av gruppe g sine kontakter som er syke i periode t

         IB       Ytterligere sykehuskapasitet intensivbehandling
         Y(T, G)  Antall som skal vaksineres i steg t gruppe g

         @V       Antall som skal vaksineres totalt
         @TS   Antall syke totalt
         Z        Totale kostnader

POSITIVE VARIABLE Y, I, M, S, L, IB, V, TS;




         S.up(T, G) = AM(G)+AS(G);


         M.up(T, G) = AM(G)  ;


         I.up(T, G) = N(G)  ;


         Y.up(T, G) = AM(G);


EQUATIONS
         Cost                 Define objective function

         AntallII(T, G)       Antall immune initielt gruppe g
         AntallMI(T, G)       Antall mottakelige initielt gruppe g
         AntallSI(T, G)       Antall syke initielt gruppe g

         AntallI(T, G)        Antall immune i periode t gruppe g
         AntallM(T, G)        Antall mottakelige i periode t gruppe g
         AntallS(T, G)        Antall syke i periode t gruppe g

*         SmitteRisiko(T, G)   Andel av gruppe g sine kontakter som er syke

         VaksineKap1(T)       Antall tilgjengelige vaksiner fr periode t
         VaksineKap2(T)       Antall tilgjengelige vaksiner i periode t
         VaksineKap3(T)       Antall tilgjengelige vaksiner etter periode t


         SykehusKap(T)        Antall tilgjengelige plasser p sykehus i periode t
         IntensivKap(T)       Antall tilgjengelige plasser p intensivavdelingen i periode t;


*Likningene:

  Cost ..        Z    =E=  SUM((T,G) , (CV + CH + CB(G)*KB(G))*Y(T, G) + (CF(G) + CS*KS(G))*S(T, G)) + CIB*IB ;

  AntallII(T, G)$(ord(T) eq 1)  .. I(T, G) =E= AI(G);
  AntallMI(T, G)$(ord(T) eq 1)  .. M(T, G) =E= AM(G);
  AntallSI(T, G)$(ord(T) eq 1)  .. S(T, G) =E= AS(G);

  AntallI(T, G)$(ord(T) gt 1) ..  I(T, G)  =E= I(T-1, G) + S(T-1, G)+ Y(T-1, G)*E;
  AntallM(T, G)$(ord(T) gt 1) ..  M(T, G)  =E= M(T-1, G) - S(T, G)- Y(T-1, G)*E;
  AntallS(T, G)$(ord(T) gt 1) ..  S(T,G)   =E= M(T-1, G) * W(G)*BETA(G)*SUM(J, U(G,J)*(S(T-1,J)/N(J)));
*  AntallS(T, G)$(ord(T) gt 1) ..  S(T,G)   =E= M(T-1, G) * L(T-1, G);

*  SmitteRisiko(T, G)$(ord(T))..L(T, G)=E= W(G)*BETA(G)*SUM(J, U(G,J)*(S(T,J)/N(J)));

  VaksineKap1(T)$(ord(T) lt 23) .. SUM(G, Y(T, G)) =E= 0;
  VaksineKap2(T)$(ord(T) eq 23) .. SUM(G, Y(T, G)) =L= QV;
  VaksineKap3(T)$(ord(T) gt 23) .. SUM(G, Y(T, G)) =L= QV;

  SykehusKap(T)$(ord(T)) .. SUM(G, KS(G)*S(T, G)) =L= QS;
  IntensivKap(T)$(ord(T)) ..  SUM(G, KIB(G)*KS(G)*S(T, G)) =L= QIB + IB;

 Option Reslim=201600;
 Option nlp = baron;
 Option optcr = 0.0;

MODEL vaksinemodell /ALL/ ;

vaksinemodell.optfile=1 ;
SOLVE vaksinemodell USING NLP MINIMIZING Z ;

DISPLAY vaksinemodell.MODELSTAT,vaksinemodell.SOLVESTAT, vaksinemodell.marginals,
vaksinemodell.numDepnd, vaksinemodell.numInfes, vaksinemodell.numNLIns ;

DISPLAY Z.L;


execute_unload "AResultsGrupperSyke.gdx"  S.L;
execute 'gdxxrw.exe AResultsGrupperSyke.gdx var=S.L rdim=1 cdim=1'


execute_unload "AResultsGrupperMottakelige.gdx"  M.L;
execute 'gdxxrw.exe AResultsGrupperMottakelige.gdx var=M.L rdim=1 cdim=1'



execute_unload "AResultsGrupperVaksinerte.gdx"  Y.L;
execute 'gdxxrw.exe AResultsGrupperVaksinerte.gdx var=Y.L rdim=1 cdim=1'

