$eolcom @

SETS
         T   Sett av tidsperioder   / 1*30 /
         W   Sett av smittescenario /1*3/
         TH  Sett av effektscenarioer /1*3/
         G   Totalt sett av grupper /1*3/ ;
             alias(G, J);


SCALARS
* alle kostnader er oppgitt i 1000

         QS  kapasitet sykehusplasser /10000/
         QV1 total kapasitet vaksinebeholdning i frste steg /440000/
         QV2 kapasitet vaksinebeholdning per uke i steg 2 /88000/
         QIB initiell kapasitet for intensivbehandling /300/

* helsepersonell tas ikke med her fordi vaksinetilgangen blir den begrensende faktor

         CS  sykehuskostnad per opphold /64.75/
         CH  kostnad per vaksine helsepersonale /0.060/
         CV  vaksinekostnad /0.08/
         CIB  kostnad per ytterlige intensivplasser /204/
         ;

PARAMETERS
         CF(G)  kostnad ved fravr per dag per person i gruppe g / 1 0.448
                                                                   2 0.700
                                                                   3 0/

         CB(G)  kostnad bivirkninger per person i gruppe g /1 2318.343
                                                            2 2205.363
                                                            3 1689.999 /



         KB(G)  Andel av vaksinerte i gruppe g som fr bivirkninger /1 0.00012
                                                                     2 0.00002
                                                                     3 0 /

         KS(G)  Andel av syke i gruppe g som kommer p sykehus /1 0.0012
                                                                2 0.0017
                                                                3 0.0047 /

         KIB(G) Andel av pasienter i gruppe g som m ha intensivbehandling /1 0.0573
                                                                            2 0.2003
                                                                            3 0.1176 /


         AI(G)  Antall immune initielt i gruppe g /1 0
                                                   2 319642
                                                  3 123323  /

         N(G)   Antall personer i gruppe g /1 1231430
                                            2 2951208
                                            3 616614/


         GA(G)   Per individ kontaktrate for gruppe g (lik for alle perioder) /1  15.3
                                                                              2  13
                                                                              3  8.2 /



         E(TH)  Vaksineeffekt ved utfall th /1  0.95
                                             2  0.8
                                             3  0.65 /




         PW(W)  Sannsynligheter for smitteutfall w / 1 0.47
                                                     2 0.35
                                                     3 0.18/


         PTH(TH) Sannsynligheter for effektutfall th /1 0.25
                                                      2 0.60
                                                      3 0.15 /

         TABLE BETA(G, W) Sannynlighet for smitte ved kontakt for gruppe g scenario w

                        1            2            3

               1    0.111        0.113        0.115
               2    0.098        0.100        0.102
               3    0.060        0.062        0.064




         TABLE  U(G,J) Andel av gruppe g sine kontakter som er med gruppe j
                      1       2      3

              1    0.79    0.20   0.02
              2    0.10    0.84   0.06
              3    0.06    0.46   0.49


         TABLE AM(G, W)  Antall mottakelige initielt i gruppe g i steg 2 scenario w

                        1          2          3
           1      1089877    1032213     959152
           2      2536311    2492392    2432223
           3       488773     486551     483416


         TABLE AS2(G, W)  Antall syke initielt i gruppe g i steg 2 scenario w

                      1            2            3

         1        33982        45018        56560
         2        32950        48094        66564
         3         1599         2407         3481


         TABLE AS1(G, W) Antall syke totalt fr steg 2 scenario w
                       1             2             3

          1       141553        199217        272278
          2        95255        139174        199343
          3         4518          6740          9875




VARIABLES



         I(T, W, TH, G)  Antall immune i periode t gruppe g scenario w theta
         M(T, W, TH, G)  Antall mottakelige i periode t gruppe g scenario w theta
         S(T, W, TH, G)  Antall syke i periode t gruppe g scenario w theta

*L(T, W, TH, G)  Andel av gruppe g som risikerer  bli smittet i periode t scenario w theta

         X(G)            Antall i gruppe g som skal vaksineres steg 1
         Y(T,W, TH, G)   Antall som skal vaksineres i gruppe g i periode t steg 2 scenario w theta
         IB              Ytterligere sykehuskapasitet

         Z               Totale kostnader

POSITIVE VARIABLE X, I, M, S, L, IB, Y;


         M.up(T, W, TH, G) = AM(G, W);

         S.up(T, W, TH, G) = AM(G, W);

         I.up(T, W, TH, G) = N(G);

*L.up(T, W, TH, G) = 1;

         X.up(G) = N(G);

         Y.up(T, W, TH, G) = AM(G, W);

EQUATIONS
         Cost                        Define objective function

         AntallII(T, W, TH, G)       Antall immune initielt i steg 2
         AntallMI(T, W, TH, G)       Antall mottakelige initielt i steg 2
         AntallSI(T, W, TH, G)       Antall syke initielt i steg 2

         AntallI(T, W, TH, G)        Antall immune i steg 2 periode t
         AntallM(T, W, TH, G)        Antall mottakelige i steg 2 periode t
         AntallS(T, W, TH, G)        Antall syke i steg 2 periode t

*SmitteRisiko(T, W, TH, G)   Andel av gruppe g sine kontakter som er syke

         VaksineKap1                 Antall tilgjengelige vaksiner i steg 1
         VaksineKap2(T, W, TH)       Antall tilgjengelige vaksiner i periode t steg 2
         SykehusKap(T, W, TH)        Antall tilgjengelige plasser p sykehus i periode t
         IntensivKap(T, W, TH)       Intensivkapasitet i periode t scenario w;



*Likningene:

         Cost ..        Z    =E=  SUM(G, (CV + CH + CB(G)*KB(G))*X(G))+ CIB*IB +  SUM((T, W, TH, G), PW(W) * PTH(TH) * ((CV + CH + CB(G)*KB(G))*Y(T, W, TH, G) + (CF(G) + CS*KS(G))*S(T, W, TH, G) )) + SUM((G, W), PW(W)*AS1(G, W)*(CF(G) + CS*KS(G)));

         AntallII(T, W, TH, G)$(ord(T) eq 1) .. I(T, W, TH, G) =E= AI(G) + X(G) * E(TH) + AS1(G, W);
         AntallMI(T, W, TH, G)$(ord(T) eq 1) .. M(T, W, TH, G) =E= AM(G, W) - X(G) * E(TH)- AS1(G, W);
         AntallSI(T, W, TH, G)$(ord(T) eq 1) .. S(T, W, TH, G) =E= AS2(G, W);

         AntallI (T, W, TH, G)$(ord(T) gt 1) .. I(T, W, TH, G) =E= I(T-1, W, TH, G) + S(T-1, W, TH, G) + Y(T-1, W, TH, G)*E(TH);
         AntallM(T, W, TH, G)$(ord(T) gt 1)  .. M(T, W, TH, G) =E= M(T-1, W, TH, G) - Y(T-1, W, TH, G) * E(TH) - S(T, W, TH, G);
*AntallS(T, W, TH, G)$(ord(T) gt 1)  .. S(T, W, TH, G) =E= M(T-1, W, TH, G) * L(T-1, W, TH, G);
         AntallS(T, W, TH, G)$(ord(T) gt 1) ..  S(T, W, TH, G) =E= M(T-1, W, TH, G) * GA(G)*BETA(G, W)*SUM(J, U(G,J)*(S(T-1,W, TH, J)/N(J)));

*SmitteRisiko(T, W, TH, G)$(ord(T))  .. L(T, W, TH, G) =E= GA(G) * BETA(G, W) * sum(J, U(G,J)*(S(T, W, TH, J) / N(J)));

         VaksineKap1 .. sum (G, X(G)) =L= QV1;
         VaksineKap2(T, W, TH)$(ord(T))  .. sum (G, Y(T, W, TH, G)) =L= QV2;

         SykehusKap(T, W, TH)$(ord(T)) .. sum (G, KS(G)*S(T, W, TH, G)) =L= QS;
         IntensivKap(T, W, TH)$(ord(T)).. sum (G, KIB(G)*KS(G)*S(T, W, TH, G)) =L= QIB + IB ;



Option Reslim=50400;
Option nlp = baron;
Option optcr = 0.01;

MODEL Vaksinemodell /ALL/ ;
vaksinemodell.optfile=1 ;

SOLVE vaksinemodell USING NLP MINIMIZING Z ;

DISPLAY vaksinemodell.MODELSTAT,vaksinemodell.SOLVESTAT, vaksinemodell.marginals,
vaksinemodell.numDepnd, vaksinemodell.numInfes, vaksinemodell.numNLIns ;

@Display  V.L ;
@Display TS.L;

execute_unload "BResultsSyke.gdx"  S.L;
execute 'gdxxrw.exe BResultsSyke.gdx var=S.L rdim=1 cdim=3'

execute_unload "BResultsVaksinerteX.gdx"  X.L;
execute 'gdxxrw.exe BResultsVaksinerteX.gdx var=X.L rdim=0 cdim=1'

execute_unload "BResultsVaksinerteY.gdx"  Y.L;
execute 'gdxxrw.exe BResultsVaksinerteY.gdx var=Y.L rdim=1 cdim=3'
