$eolcom @

SETS
         T        Sett av tidsperioder   / 1*23 /
         W        Sett av smittescenario /1*3/
         TH1       Sett av effektscenarioer /1*3/
         G        Totalt sett av grupper /1*3/
         D        Sett av vaksinetyper /1*2/ ;
                  alias(G, J);
                  alias(TH1, TH2);

SCALARS
* alle kostnader er oppgitt i 1000

         QS  Kapasitet sykehusplasser /10000/
         QIB Initiell kapasitet for intensivbehandling /300/

* helsepersonell tas ikke med her fordi vaksinetilgangen QV1 og QV2 blir den begrensende faktor

         CS  Sykehuskostnad per opphold /64.75/
         CH  Kostnad per vaksine helsepersonale /0.060/
         CIB Kostnad per ytterlige intensivplasser /204/

         ;

PARAMETERS

         QV1(D) Total kapasitet vaksinetype d i frste steg /1 440000
                                                             2  44000/

         QV2(D) Kapasitet vaksinetype d per uke i steg 2 /1 88000
                                                          2  8800/


         CV(D)  Vaksinekostnad for vaksinetype d /1 0.08
                                                  2 0.112/

         CF(G)  Kostnad ved fravr per dag per person i gruppe g / 1 0.448
                                                                   2 0.700
                                                                   3 0  /

         CB(G)  Kostnad bivirkninger per person i gruppe g /1 2318.343
                                                            2 2205.363
                                                            3 1689.999  /


         KB(G) Andel av vaksinerte i gruppe g som fr bivirkninger  /1 0.00012
                                                                     2 0.00002
                                                                     3 0 /


         KS(G)  Andel av syke i gruppe g som kommer p sykehus /1 0.0012
                                                                2 0.0017
                                                                3 0.0047 /

         KIB(G) Andel av pasienter i gruppe g som m ha intensivbehandling /1 0.0573
                                                                            2 0.2003
                                                                            3 0.1176 /

         N(G)  Antall personer i gruppe g /1 1231430
                                            2 2951208
                                            3 616614/





         AI(G)  Antall immune initielt i steg 1 i gruppe g /1 0
                                                            2 319642
                                                            3 123323  /


         GA(G)   Gjennomsnittlig antall kontakter per person i gruppe g  /1 15.3
                                                                          2 13
                                                                          3 8.2/



         E1(TH1)  Vaksineeffekt ved bruk av vaksinetype 1 og effektutfall TH1 /1  0.95
                                                                               2  0.80
                                                                               3  0.65/

         E2(TH2)  Vaksineeffekt ved bruk av vaksinetype 2 og effektutfall TH2 /1  0.95
                                                                               2  0.80
                                                                               3  0.65/


         PTH1(TH1) Sannsynlighet for at effektutfall TH1 inntreffer for vaksinetype 1 /1 0.25
                                                                                       2 0.60
                                                                                       3 0.15/

         PTH2(TH2) Sannsynlighet for at effektutfall TH2 inntreffer for vaksinetype 2 /1 0.60
                                                                                       2 0.40
                                                                                       3 0.00/




         PW(W)  Sannsynligheter for smitteutfall w / 1 0.47
                                                     2 0.35
                                                     3 0.18 /


TABLE AM(G, W)  Antall mottakelige initielt i gruppe g i steg 2 scenario w

                        1          2          3
           1      1089877    1032213     959152
           2      2536311    2492392    2432223
           3       488773     486551     483416

TABLE   AS1(G, W)  Antall syke akkumulert i steg 1 i gruppe g scenario w
            1         2        3
      1   141553   199217   272278
      2    95255   139174   199343
      3     4518     6740     9875

TABLE
         AS2(G,W)  Antall syke initielt i gruppe g i steg 2 scenario w

                     1      2        3
              1     33982  45018   56560
              2     32950  48094   66564
              3      1599   2407    3481

TABLE  U(G,J) Andel av gruppe g dine kontakter som er med gruppe j
            1           2           3
1           0.79        0.20        0.02
2           0.10        0.84        0.06
3           0.06        0.46        0.49

TABLE BETA(W, G) Sannynlighet for smitte ved kontakt for gruppe g scenario w

                       1        2      3
               1     0.111   0.098   0.060
               2     0.113   0.100   0.062
               3     0.115   0.102   0.064



VARIABLES


         I(T, W, TH1, TH2, G)    Antall immune i periode t gruppe g scenario w theta
         M(T, W, TH1, TH2, G)    Antall mottakelige i periode t gruppe g scenario w theta
         S(T, W, TH1, TH2, G)    Antall syke i periode t gruppe g scenario w theta

*         L(T, W, TH, G)  Andel av gruppe g som risikerer  bli smittet i periode t scenario w theta
         PTOT(TH1, TH2)          Sannsynlighet for at effektutfall TH1 inntreffer samtidig som TH2
         ETOT1(TH1, TH2)          Effektutfall nr TH1 inntreffer samtidig som TH2 i steg 1
         ETOT2(W, TH1, TH2)          Effektutfall nr TH1 inntreffer samtidig som TH2 i smitteutfall w i steg 2

         X(G)                    Antall som skal vaksineres i gruppe g steg 1
         Y(T, W, TH1, TH2, G)    Antall som skal vaksineres i gruppe g steg 2 periode t scenario w theta
         IB                      Ytterligere sykehuskapasitet
         DE1(D)                   Vektingsvariabel steg 1 for vaksinetype d
         DE2(D, W, TH1, TH2)      Vektingsvariabel steg 2 for vaksinetype d  smitteutfall w og effektutfall th1 og th2

         Z               Totale kostnader

POSITIVE VARIABLE  I, M, S, PTOT, ETOT1, ETOT2, X, Y, IB, DE1, DE2;

         I.up(T, W, TH1, TH2, G) = N(G);

         M.up(T, W, TH1, TH2, G) = AM(G, W);

         S.up(T, W, TH1, TH2, G) = AM(G, W);

         X.up(G) = N(G);

         Y.up(T, W, TH1, TH2, G) = AM(G, W);


         PTOT.up(TH1, TH2) = 1;
         ETOT1.up(TH1, TH2) = 1;
         ETOT2.up(W, TH1, TH2) = 1;

         DE1.up(D) = 1;
         DE2.up(D, W, TH1, TH2) = 1;

EQUATIONS

         Cost                        Define objective function

         EffektTot1(TH1, TH2)         Total effekt i befolkningen
         EffektTot2(W, TH1, TH2)         Total effekt i befolkningen
         Sannsynlighet(TH1, TH2)     Sannsynlighet for at scenario TH1 og TH2 inntreffer samtidig
         DeltaTot1                     Summen av vektingsvariabel i steg 1
         DeltaTot2(W, TH1, TH2)         Summen av vektingsvariabel i steg 2

         AntallII(T, W, TH1, TH2, G)       Antall immune initielt i steg 2
         AntallMI(T, W, TH1, TH2, G)       Antall mottakelige initielt i steg 2
         AntallSI(T, W, TH1, TH2, G)       Antall syke initielt i steg 2

         AntallI(T, W, TH1, TH2, G)        Antall immune i steg 2 periode t
         AntallM(T, W, TH1, TH2, G)        Antall mottakelige i steg 2 periode t
         AntallS(T, W, TH1, TH2, G)        Antall syke i steg 2 periode t

*         SmitteRisiko(T, W, TH, G)   Andel av gruppe g sine kontakter som er syke

         VaksineKapHelse1            Antall tilgjengelige helsepersonell i steg 1
         VaksineKapHelse2(T, W, TH1, TH2)  Antall tilgjengelige helsepersonell i periode t steg 2

         VaksineKapTypeD1(D)            Antall tilgjengelige vaksiner av type d i steg 1
         VaksineKapTypeD2(T, W, TH1, TH2, D)  Antall tilgjengelige vaksiner av type d per periode i steg 2

         SykehusKap(T, W, TH1, TH2)        Antall tilgjengelige plasser p sykehus i periode t
         IntensivKap(T, W, TH1, TH2)       Intensivkapasitet i periode t scenario w;



*Likningene:



         Cost                    ..   Z =E= sum(G, (sum(D, CV(D)*DE1(D))+ CH + CB(G)*KB(G))*X(G))+ CIB*IB + sum((T, W, TH1, TH2, G), PW(W)*PTOT(TH1, TH2)*( (sum(D, CV(D)*DE2(D, W, TH1, TH2)) + CH + CB(G)*KB(G))*Y(T, W, TH1, TH2, G) + (CF(G) + CS*KS(G))*S(T, W, TH1, TH2, G)))+ SUM((G, W), PW(W)*AS1(G, W)*(CF(G) + CS*KS(G)));
         EffektTot1(TH1, TH2) .. ETOT1(TH1, TH2) =E= DE1('1')*E1(TH1) + DE1('2')*E2(TH2);
         EffektTot2(W, TH1, TH2) .. ETOT2(W, TH1, TH2) =E= DE2('1', W, TH1, TH2)*E1(TH1) + DE2('2', W, TH1, TH2)*E2(TH2);
         Sannsynlighet(TH1, TH2)   .. PTOT(TH1, TH2) =E= PTH1(TH1)*PTH2(TH2);

         DeltaTot1 .. sum(D, DE1(D)) =E= 1;
         DeltaTot2(W, TH1, TH2) .. sum(D, DE2(D, W, TH1, TH2)) =E= 1;

         AntallII(T, W, TH1, TH2, G)$(ord(T) eq 1) ..  I(T, W, TH1, TH2, G) =E= AI(G) + X(G) * ETOT1(TH1, TH2) + AS1(G, W);
         AntallMI(T, W, TH1, TH2, G)$(ord(T) eq 1) ..  M(T, W, TH1, TH2, G) =E= AM(G, W) - X(G)*ETOT1(TH1, TH2) - AS1(G, W);
         AntallSI(T, W, TH1, TH2, G)$(ord(T) eq 1) ..  S(T, W, TH1, TH2, G) =E= AS2(G, W);

         AntallI(T, W, TH1, TH2, G)$(ord(T) gt 1)  ..  I(T, W, TH1, TH2, G) =E= I(T-1, W, TH1, TH2, G) + S(T-1, W, TH1, TH2, G) + Y(T-1, W, TH1, TH2, G)*ETOT2(W, TH1, TH2);
         AntallM(T, W, TH1, TH2, G)$(ord(T) gt 1)  ..  M(T, W, TH1, TH2, G) =E= M(T-1, W, TH1, TH2, G) - Y(T-1, W, TH1, TH2, G)*ETOT2(W, TH1, TH2) - S(T, W, TH1, TH2, G);
         AntallS(T, W, TH1, TH2, G)$(ord(T) gt 1)  ..  S(T, W, TH1, TH2, G) =E= M(T-1, W, TH1, TH2, G) * GA(G) * BETA(W, G) * sum(J, U(G,J)*(S(T-1, W, TH1, TH2, J) / N(J)));
*         AntallS(T, W, TH, G)$(ord(T) gt 1)  ..  S(T, W, TH, G) =E= M(T-1, W, TH, G) * L(T-1, W, TH, G);

*         SmitteRisiko(T, W, TH, G)$(ord(T))  .. L(T, W, TH, G) =E= GA(G) * BETA(W, G) * sum(J, U(G,J)*(S(T, W, TH, J) / N(J)));

         VaksineKapHelse1      .. sum(G, X(G)) =L= QV1('1');
         VaksineKapHelse2(T, W, TH1, TH2) .. sum(G, Y(T, W, TH1, TH2, G)) =L= QV2('1');

         VaksineKapTypeD1(D)          ..sum(G, DE1(D)*X(G)) =L= QV1(D);
         VaksineKapTypeD2(T, W, TH1, TH2, D) .. sum(G, DE2(D, W, TH1, TH2)*Y(T, W, TH1, TH2, G)) =L= QV2(D);

         SykehusKap(T, W, TH1, TH2) .. sum (G, KS(G)*S(T, W, TH1, TH2, G)) =L= QS;
         IntensivKap(T, W, TH1, TH2) .. sum (G, KIB(G)*KS(G)*S(T, W, TH1, TH2, G)) =L= QIB + IB;



Option Reslim=5000;
Option nlp = baron;
Option optcr = 0.1;

MODEL Vaksinemodell /ALL/ ;
vaksinemodell.optfile=1 ;

SOLVE vaksinemodell USING NLP MINIMIZING Z ;

DISPLAY vaksinemodell.MODELSTAT,vaksinemodell.SOLVESTAT, vaksinemodell.marginals,
vaksinemodell.numDepnd, vaksinemodell.numInfes, vaksinemodell.numNLIns ;

execute_unload "IResultsSyke.gdx"  S.L;
execute 'gdxxrw.exe IResultsSyke.gdx var=S.L rdim=1 cdim=4'

execute_unload "IResultsVaksinerteX.gdx"  X.L;
execute 'gdxxrw.exe IResultsVaksinerteX.gdx var=X.L rdim=0 cdim=1'

execute_unload "IResultsVaksinerteY.gdx"  Y.L;
execute 'gdxxrw.exe IResultsVaksinerteY.gdx var=Y.L rdim=1 cdim=4'
