$eolcom @

SETS
         T        Sett av tidsperioder   / 1*23 /
         W        Sett av smittescenario /1*3/
         TH       Sett av effektscenarioer /1*3/
         G        Totalt sett av grupper /1*3/
         S1(TH)   Sett av effektscenarier som kan endres p /1/
         S2(TH)   Sett av effektscenarier som ikke kan endres p /2*3/ ;
                  alias(G, J);
                  alias(TH, THH);

SCALARS
* alle kostnader er oppgitt i 1000

         QS  Kapasitet sykehusplasser /10000/
         QV1 Total kapasitet vaksinebeholdning i frste steg /440000/
         QV2 Kapasitet vaksinebeholdning per uke i steg 2 /88000/
         QIB Initiell kapasitet for intensivbehandling /300/

*helsepersonell tas ikke med her fordi vaksinetilgangen blir den begrensende faktor

         CS  Sykehuskostnad per opphold /64.75/
         CH  Kostnad per vaksine helsepersonale /0.060/
         CV  Vaksinekostnad /0.08/
         CIB Kostnad per ytterlige intensivplasser /204/
         CA  Kostnad ved ytterligere forskning og testing av vaksine /12250/
         ;
PARAMETERS
         CF(G)  Kostnad ved fravr per dag per person i gruppe g / 1 0.448
                                                                   2 0.700
                                                                   3 0  /

         CB(G)  Kostnad bivirkninger per person i gruppe g /1 2318.343
                                                            2 2205.363
                                                            3 1689.999  /



         KB(G)  Andel av vaksinerte i gruppe g som fr bivirkninger /1 0.00012
                                                                     2 0.00002
                                                                     3 0 /

         KS(G)  Andel av syke i gruppe g som kommer p sykehus /1 0.0012
                                                                2 0.0017
                                                                3 0.0047 /

         KIB(G) Andel av pasienter i gruppe g som m ha intensivbehandling /1 0.0573
                                                                            2 0.2003
                                                                            3 0.1176 /



         AI(G)  Antall immune initielt i steg 1 i gruppe g /1 0
                                                            2 319642
                                                            3 123323  /

         N(G)   Antall personer i gruppe g /1 1231430
                                            2 2951208
                                            3 616614/


         GA(G)  Gjennomsnittlig antall kontakter per person i gruppe g  /1 15.3
                                                                         2 13
                                                                         3 8.2/



         E(TH)  Vaksineeffekt ved utfall theta /1  0.95
                                                2  0.80
                                                3  0.65/




         PW(W)  Sannsynligheter for smitteutfall w / 1 0.47
                                                     2 0.35
                                                     3 0.18 /


         PTH(TH) Initielle sannsynligheter for effektutfall theta /1 0.25
                                                                   2 0.60
                                                                   3 0.15 /



TABLE AM(G, W)  Antall mottakelige initielt i gruppe g i steg 2 scenario w

                        1          2          3
           1      1089877    1032213     959152
           2      2536311    2492392    2432223
           3       488773     486551     483416


TABLE   AS1(G, W)  Antall syke akkumulert i steg 1 i gruppe g scenario w
            1         2        3
      1   141553   199217   272278
      2    95255   139174   199343
      3     4518     6740     9875

TABLE
         AS2(G,W)  Antall syke initielt i gruppe g i steg 2 scenario w

                     1      2        3
              1     33982  45018   56560
              2     32950  48094   66564
              3      1599   2407    3481


TABLE  U(G,J) Andel av gruppe g dine kontakter som er med gruppe j
            1           2           3
1           0.79        0.20        0.02
2           0.10        0.84        0.06
3           0.06        0.46        0.49

TABLE BETA(W, G) Sannynlighet for smitte ved kontakt for gruppe g scenario w

                       1        2      3
               1     0.111   0.098   0.060
               2     0.113   0.100   0.062
               3     0.115   0.102   0.064


VARIABLES


         I(T, W, TH, G)  Antall immune i periode t gruppe g scenario w theta
         M(T, W, TH, G)  Antall mottakelige i periode t gruppe g scenario w theta
         S(T, W, TH, G)  Antall syke i periode t gruppe g scenario w theta

*         L(T, W, TH, G)  Andel av gruppe g som risikerer  bli smittet i periode t scenario w theta
         P(TH)           Sannsynlighet for effektutfall  theta

         X(G)            Antall som skal vaksineres i gruppe g steg 1
         Y(T, W, TH, G)  Antall som skal vaksineres i gruppe g steg 2 periode t scenario w theta
         IB              Ytterligere sykehuskapasitet
         A               Skaleringsfaktor som bestemmer mengde vaksineforskning

         Z               Totale kostnader



POSITIVE VARIABLE I, M, S, P, X, Y, IB, A;

         I.up(T, W, TH, G) = N(G);

         M.up(T, W, TH, G) = AM(G, W);

         S.up(T, W, TH, G) = AM(G, W);

         X.up(G) = N(G);

         Y.up(T, W, TH, G) = AM(G, W);

         P.up(TH) = 1;

         A.lo = 1;


EQUATIONS

         Cost                        Define objective function

         Sannsynlighet1(TH)          Sannsynlighet i nsket scenario theta
         Sannsynlighet2(TH)          Sannsynlighet i alle andre scenarier theta
         SannsynlighetTotalt         Total sannsynlighet kan ikke overstige 1

         AntallII(T, W, TH, G)       Antall immune initielt i steg 2
         AntallMI(T, W, TH, G)       Antall mottakelige initielt i steg 2
         AntallSI(T, W, TH, G)       Antall syke initielt i steg 2

         AntallI(T, W, TH, G)        Antall immune i steg 2 periode t
         AntallM(T, W, TH, G)        Antall mottakelige i steg 2 periode t
         AntallS(T, W, TH, G)        Antall syke i steg 2 periode t

*         SmitteRisiko(T, W, TH, G)   Andel av gruppe g sine kontakter som er syke

         VaksineKap1                 Antall tilgjengelige vaksiner i steg 1
         VaksineKap2(T, W, TH)       Antall tilgjengelige vaksiner i periode t steg 2
         SykehusKap(T, W, TH)        Antall tilgjengelige plasser p sykehus i periode t
         IntensivKap(T, W, TH)       Intensivkapasitet i periode t scenario w ;



*Likningene:

         Cost                    .. Z =E= sum(G, (CV + CH + CB(G)*KB(G))*X(G))+ CIB*IB + CA*(A-1) + sum((T, W, TH, G), PW(W)*P(TH)*( (CV + CH + CB(G)*KB(G))*Y(T, W, TH, G) + (CF(G) + CS*KS(G))*S(T, W, TH, G)))+ sum((W, G), PW(W)*AS1(G, W)*(CF(G) + CS*KS(G)));


         Sannsynlighet1(TH) $S1(TH)     .. P(TH) =E= A * PTH(TH);
         Sannsynlighet2(TH)$S2(TH)  .. P(TH) =E= ((1 - A * sum(THH $S1(THH), PTH(THH)))/ (sum(THH $ S2(THH), PTH(THH))) * PTH(TH));
         SannsynlighetTotalt .. SUM(S1(TH), P(TH)) =L= 1;

         AntallII(T, W, TH, G)$(ord(T) eq 1) .. I(T, W, TH, G) =E= AI(G) + X(G) * E(TH + AS1(G, W));
         AntallMI(T, W, TH, G)$(ord(T) eq 1) .. M(T, W, TH, G) =E= AM(G, W) - X(G)*E(TH) - AS1(G, W);
         AntallSI(T, W, TH, G)$(ord(T) eq 1) .. S(T, W, TH, G) =E= AS2(G, W);

         AntallI (T, W, TH, G)$(ord(T) gt 1) .. I(T, W, TH, G) =E= I(T-1, W, TH, G) + S(T-1, W, TH, G) + Y(T-1, W, TH, G)*E(TH);
         AntallM(T, W, TH, G)$(ord(T) gt 1)  .. M(T, W, TH, G) =E= M(T-1, W, TH, G) - Y(T-1, W, TH, G)*E(TH) - S(T, W, TH, G);
         AntallS(T, W, TH, G)$(ord(T) gt 1)  .. S(T, W, TH, G) =E= M(T-1, W, TH, G) *  GA(G) * BETA(W, G) * sum(J, U(G,J)*(S(T-1, W, TH, J) / N(J)));
*         AntallS(T, W, TH, G)$(ord(T) gt 1)  .. S(T, W, TH, G) =E= M(T-1, W, TH, G) *  L(T-1, W, TH, G);

*         SmitteRisiko(T, W, TH, G)$(ord(T))  .. L(T, W, TH, G) =E= GA(G) * BETA(W, G) * sum(J, U(G,J)*(S(T, W, TH, J) / N(J)));

         VaksineKap1 .. SUM (G, X(G)) =L= QV1;
         VaksineKap2(T, W, TH)$(ord(T)) .. SUM (G, Y(T, W, TH, G)) =L= QV2;
         SykehusKap(T, W, TH)$(ord(T)) .. SUM (G, KS(G)*S(T, W, TH, G)) =L= QS;
         IntensivKap(T, W, TH)$(ord(T)) .. SUM (G, KIB(G)*KS(G)*S(T, W, TH, G)) =L= QIB + IB;



Option Reslim=50000;
Option nlp = baron;
Option optcr = 0.1;

MODEL Vaksinemodell /ALL/ ;
vaksinemodell.optfile=1 ;

SOLVE vaksinemodell USING NLP MINIMIZING Z ;

DISPLAY vaksinemodell.MODELSTAT,vaksinemodell.SOLVESTAT, vaksinemodell.marginals,
vaksinemodell.numDepnd, vaksinemodell.numInfes, vaksinemodell.numNLIns ;

execute_unload "CResultsSyke.gdx"  S.L;
execute 'gdxxrw.exe CResultsSyke.gdx var=S.L rdim=1 cdim=3'

execute_unload "CResultsVaksinerteX.gdx"  X.L;
execute 'gdxxrw.exe CResultsVaksinerteX.gdx var=X.L rdim=1 cdim=1'

execute_unload "CResultsVaksinerteY.gdx"  Y.L;
execute 'gdxxrw.exe CResultsVaksinerteY.gdx var=Y.L rdim=1 cdim=3'
