$eolcom @

SETS
         T   Sett av tidsperioder   / 1*23 /
         W   Sett av smittescenario /1*3/
         E   Sett av responsutfall for befolkningen ved vaksinering /1*3/
         G   Totalt sett av grupper /1*3/ ;
             alias(G, J);


SCALARS
* alle kostnader er oppgitt i 1000

         QS  kapasitet sykehusplasser /10000/
         QV1 total kapasitet vaksinebeholdning i frste steg /440000/
         QV2 kapasitet vaksinebeholdning per uke i steg 2 /88000/
         QIB initiell kapasitet for intensivbehandling /300/

* helsepersonell tas ikke med her fordi vaksinetilgangen blir den begrensende faktor

         CS  sykehuskostnad per opphold /64.75/
         CH  kostnad per vaksine helsepersonale /0.060/
         CV  vaksinekostnad /0.08/
         CIB  kostnad per ytterlige intensivplasser /204/
         ;
PARAMETERS
         CF(G)  kostnad ved fravr per dag per person i gruppe g / 1 0.448
                                                                   2 0.700
                                                                   3 0  /

         CB(G)  kostnad bivirkninger per person i gruppe g /1 2318.343
                                                            2 2205.363
                                                            3 1689.999  /



         KB(G)  Andel av vaksinerte i gruppe g som fr bivirkninger /1 0.00012
                                                                     2 0.00002
                                                                     3 0 /

         KS(G)  Andel av syke i gruppe g som kommer p sykehus /1 0.0012
                                                                2 0.0017
                                                                3 0.0047 /

         KIB(G) Andel av pasienter i gruppe g som m ha intensivbehandling /1 0.0573
                                                                            2 0.2003
                                                                            3 0.1176 /

         N(G)  Antall personer i gruppe g /1 1231430
                                           2 2951208
                                           3 616614/




         AI(G)  Antall immune initielt i gruppe g /1 0
                                                   2 319642
                                                   3 123323  /


         GA(G)   Gjennomsnittlig antall kontakter per person i gruppe g  /1 15.3
                                                                          2 13
                                                                          3 8.2/


         R(E)   Respons i totalbefolkningen p vaksine ved responsutfall e /1  0.64
                                                                            2  0.71
                                                                            3  0.78/




         PW(W)  Sannsynligheter for smitteutfall w / 1 0.47
                                                     2 0.35
                                                     3 0.18 /

TABLE AM(G, W)  Antall mottakelige initielt i gruppe g i steg 2 scenario w

                       1          2          3
           1      1053029     983170     896189
           2      2503025    2443809    2365353
           3       487152     484122     479901

TABLE  PWE(G, E)   Sannsynlighet for responsutfall e i gruppe g
                       1       2      3
               1     0.20   0.50   0.30
               2     0.20   0.55   0.25
               3     0.30   0.50   0.20




TABLE   AS1(G, W)  Antall syke akkumulert i steg 1 i gruppe g scenario w
            1         2        3
1        178401  248260   335241
2        128541  187757   266213
3          6139    9169    13390

TABLE
         AS2(G,W)  Antall syke initielt i gruppe g i steg 2 scenario w

                          1           2          3
             1        35786        47510        60832
             2        33225        48491        66740
             3         1612         2425         3508


TABLE  U(G,J) Andel av gruppe g dine kontakter som er med gruppe j
            1           2           3
1           0.79        0.20        0.02
2           0.10        0.84        0.06
3           0.06        0.46        0.49

TABLE BETA(W, G) Sannynlighet for smitte ved kontakt for gruppe g scenario w

                       1        2      3
               1     0.111   0.098   0.060
               2     0.113   0.100   0.062
               3     0.115   0.102   0.064

VARIABLES

         I(T, W, E, G)   Antall immune i periode t gruppe g scenario w e
         M(T, W, E, G)   Antall mottakelige i periode t gruppe g scenario w e
         S(T, W, E, G)   Antall syke i periode t gruppe g scenario w e

*         L(T, W, E, G)   Andel av gruppe g som risikerer  bli smittet i periode t scenario w theta

         X(G)            Antall i gruppe g som skal vaksineres steg 1
         Xtot
         Y1(T, W, E)      Totalt antall som skal vaksineres i steg 2 periode t scenario we
         Y2(T,W, E, G)    Antall som skal vaksineres i gruppe g i periode t steg 2 scenario w e
         IB              Ytterligere sykehuskapasitet

         P(E)            Sannsynlighet for responsutfall v for totalbefolkningen
         O(G)            Andel av totalt antall vaksinerte som tilhrer gruppe g

         Z               Totale kostnader

POSITIVE VARIABLE  I, M, S, X, Y1, Y2, IB, P, O;


         I.up(T, W, E, G) = N(G);

         M.up(T, W, E, G) = AM(G, W);

         S.up(T, W, E, G) = AM(G, W);

         X.up(G) = N(G);
         Xtot.up = N('1')+ N('2') + N('3');
         Y1.up(T, W, E) = AM('1', W)+ AM('2', W)+AM('3', W);
         Y2.up(T, W, E, G) = AM(G, W);

         P.up(E) = 1;
         O.up(G) = 1;

EQUATIONS

         Cost                       Define objective function

         TotSannsynlighet(E)        Sannsynlighet for total respons i befolkningen
         TotalAndel                 All vaksinasjon m fordeles p gruppene
         VaksinertGruppeX(G)        Andel av totalt vaksinerte i steg 1 som skal vaksineres i gruppe g
         VaksinertGruppe(T, W, E, G) Andel av totalt vaksinerte i steg 2 som skal vaksineres i gruppe g
         VaksinertTotaltX           Antall vaksinerte i steg 1 summert over gruppene m tilsvare total antall vaksinerte
         VaksinertTotalt(T, W, E)   Antall vaksinerte i steg 2 summert over gruppene m tilsvare total antall vaksinerte

         AntallII(T, W, E, G)       Antall immune initielt i steg 2
         AntallMI(T, W, E, G)       Antall mottakelige initielt i steg 2
         AntallSI(T, W, E, G)       Antall syke initielt i steg 2

         AntallI(T, W, E, G)        Antall immune i steg 2 periode t
         AntallM(T, W, E, G)        Antall mottakelige i steg 2 periode t
         AntallS(T, W, E, G)        Antall syke i steg 2 periode t

*         SmitteRisiko(T, W, TH, G)  Andel av gruppe g sine kontakter som er syke

         VaksineKap1                Antall tilgjengelige vaksiner i steg 1
         VaksineKap2(T, W, E)       Antall tilgjengelige vaksiner i periode t steg 2
         SykehusKap(T, W, E)        Antall tilgjengelige plasser p sykehus i periode t
         IntensivKap(T, W, E)       Intensivkapasitet i periode t scenario w e ;



*Likningene:


         Cost                    .. Z =E= sum(G, (CV + CH + CB(G)*KB(G))*X(G))+ CIB*IB + sum((T, W, E, G), PW(W)*P(E)*( (CV + CH + CB(G)*KB(G))*Y2(T, W, E, G) + (CF(G) + CS*KS(G))*S(T, W, E, G)))+ sum((W, G), PW(W)*AS1(G, W)*(CF(G) + CS*KS(G)));

         TotSannsynlighet(E)         ..  P(E) =E= sum(G, O(G)*PWE(G, E));
         TotalAndel                  ..  sum(G, O(G)) =E= 1;
         VaksinertGruppeX(G)         ..  O(G)*Xtot =E= X(G);
         VaksinertGruppe(T, W, E, G) ..  O(G)*Y1(T, W, E) =E= Y2(T, W, E, G);
         VaksinertTotaltX            ..  sum(G,X(G)) =E= Xtot;
         VaksinertTotalt(T, W, E)    ..  sum(G,Y2(T, W, E, G)) =E= Y1(T, W, E);

         AntallII(T, W, E, G)$(ord(T) eq 1) .. I(T, W, E, G) =E= AI(G) + X(G) * R(E) + AS1(G, W);
         AntallMI(T, W, E, G)$(ord(T) eq 1) .. M(T, W, E, G) =E= AM(G, W) -X(G)*R(E) - AS1(G, W);
         AntallSI(T, W, E, G)$(ord(T) eq 1) .. S(T, W, E, G) =E= AS2(G, W);

         AntallI (T, W, E, G)$(ord(T) gt 1) .. I(T, W, E, G) =E= I(T-1, W, E, G) + S(T-1, W, E, G) + Y2(T-1, W, E, G)*R(E);
         AntallM(T, W, E, G)$(ord(T) gt 1)  .. M(T, W, E, G) =E= M(T-1, W, E, G) - Y2(T-1, W, E, G)*R(E) - S(T, W, E, G);
         AntallS(T, W, E, G)$(ord(T) gt 1)  .. S(T, W, E, G) =E= M(T-1, W, E, G) * GA(G) * BETA(W, G) * sum(J, U(G,J)*(S(T-1, W, E, J) / N(J)));
*        AntallS(T, W, E, G)$(ord(T) gt 1)  .. S(T, W, E, G) =E= M(T-1, W, E, G) * L(T-1, W, E, G);

*        SmitteRisiko(T, W, TH, G)$(ord(T))  .. L(T, W, TH, G) =E= GA(G) * BETA(W, G) * sum(J, U(G,J)*(S(T, W, TH, J) / N(J)));

         VaksineKap1 .. SUM (G, X(G)) =L= QV1;
         VaksineKap2(T, W, E) .. Y1(T, W, E) =L= QV2;
         SykehusKap(T, W, E) .. SUM (G, KS(G)*S(T, W, E, G)) =L= QS;
         IntensivKap(T, W, E) .. SUM (G, KIB(G)*KS(G)*S(T, W, E, G)) =L= QIB + IB;



Option Reslim=50000;
Option nlp = baron;
Option optcr = 0.1;


MODEL Vaksinemodell /ALL/ ;
vaksinemodell.optfile=1 ;
SOLVE vaksinemodell USING NLP MINIMIZING Z ;
DISPLAY vaksinemodell.MODELSTAT,vaksinemodell.SOLVESTAT, vaksinemodell.marginals,
vaksinemodell.numDepnd, vaksinemodell.numInfes, vaksinemodell.numNLIns ;


execute_unload "HResultsSyke.gdx"  S.L;
execute 'gdxxrw.exe HResultsSyke.gdx var=S.L rdim=1 cdim=3'

execute_unload "HResultsVaksinerteX.gdx"  X.L;
execute 'gdxxrw.exe HResultsVaksinerteX.gdx var=X.L rdim=0 cdim=1'

execute_unload "HResultsVaksinerteY1.gdx"  Y1.L;
execute 'gdxxrw.exe HResultsVaksinerteY1.gdx var=Y1.L rdim=1 cdim=2'

execute_unload "HResultsVaksinerteY2.gdx"  Y2.L;
execute 'gdxxrw.exe HResultsVaksinerteY2.gdx var=Y2.L rdim=1 cdim=3'
